package cn.com.tenlion.systembase.service.masspreventionrank;

import cn.com.tenlion.systembase.pojo.bos.masspreventionrank.MassPreventionRankBO;
import cn.com.tenlion.systembase.pojo.dtos.masspreventionrank.MassPreventionRankDTO;
import cn.com.tenlion.systembase.pojo.pos.masspreventionrank.MassPreventionRankPO;
import cn.com.tenlion.systembase.pojo.vos.masspreventionrank.MassPreventionRankVO;
import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMassPreventionRankService
 * @Description: 群防群治队伍
 * @Author: CodeFactory
 * @Date: 2021-10-12 14:40:57
 * @Version: 3.0
 **/
public interface IMassPreventionRankService {

    /**
     * 新增群防群治队伍
     *
     * @param massPreventionRankVO
     * @return
     */
    void save(MassPreventionRankVO massPreventionRankVO);

    /**
     * 新增群防群治队伍
     *
     * @param token
     * @param massPreventionRankVO
     * @return
     */
    void save(String token, MassPreventionRankVO massPreventionRankVO);

    /**
     * 新增群防群治队伍
     *
     * @param massPreventionRankVO
     * @return massPreventionRankId
     */
    String saveReturnId(MassPreventionRankVO massPreventionRankVO);

    /**
     * 新增群防群治队伍
     *
     * @param token
     * @param massPreventionRankVO
     * @return massPreventionRankId
     */
    String saveReturnId(String token, MassPreventionRankVO massPreventionRankVO);

    /**
     * 删除群防群治队伍
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除群防群治队伍
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除群防群治队伍（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改群防群治队伍
     *
     * @param massPreventionRankId
     * @param massPreventionRankVO
     * @return
     */
    void update(String massPreventionRankId, MassPreventionRankVO massPreventionRankVO);

    /**
     * 修改群防群治队伍
     *
     * @param token
     * @param massPreventionRankId
     * @param massPreventionRankVO
     * @return
     */
    void update(String token, String massPreventionRankId, MassPreventionRankVO massPreventionRankVO);

    /**
     * 群防群治队伍详情
     *
     * @param params 参数Map
     * @return
     */
    MassPreventionRankDTO get(Map<String, Object> params);

    /**
     * 群防群治队伍详情
     *
     * @param massPreventionRankId
     * @return
     */
    MassPreventionRankDTO get(String massPreventionRankId);

    /**
     * 群防群治队伍详情
     *
     * @param params 参数Map
     * @return
     */
    MassPreventionRankBO getBO(Map<String, Object> params);

    /**
     * 群防群治队伍详情
     *
     * @param massPreventionRankId
     * @return
     */
    MassPreventionRankBO getBO(String massPreventionRankId);

    /**
     * 群防群治队伍详情
     *
     * @param params 参数Map
     * @return
     */
    MassPreventionRankPO getPO(Map<String, Object> params);

    /**
     * 群防群治队伍详情
     *
     * @param massPreventionRankId
     * @return
     */
    MassPreventionRankPO getPO(String massPreventionRankId);

    /**
     * 群防群治队伍列表
     *
     * @param params
     * @return
     */
    List<MassPreventionRankDTO> list(Map<String, Object> params);

    /**
     * 群防群治队伍列表
     *
     * @param params
     * @return
     */
    List<MassPreventionRankBO> listBO(Map<String, Object> params);

    /**
     * 群防群治队伍列表
     *
     * @param params
     * @return
     */
    List<MassPreventionRankPO> listPO(Map<String, Object> params);

    /**
     * 群防群治队伍分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MassPreventionRankDTO>> listPage(ListPage page);

    /**
     * 群防群治队伍统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

}